/// @file shell.hpp
/// VFƃt@CVXe.
#pragma once

#include "mew.hpp"
#include "widgets.hpp"
#include "path.hpp"
#include <shlobj.h>
#include <shellapi.h>

namespace mew
{
	/// VFAt@CVXeAvZXԒʐM.
	namespace io
	{
		//==============================================================================
		// C^tF[X`.

		/// VFGgz(CIDA).
		__interface IEntryList : IUnknown
		{
#ifndef DOXYGEN
			size_t get_Count();
			const ITEMIDLIST*	get_Parent();
			const ITEMIDLIST*	get_Leaf(size_t index);
#endif // DOXYGEN

			__declspec(property(get=get_Count )) size_t Count;
			__declspec(property(get=get_Parent)) const ITEMIDLIST* Parent;
			__declspec(property(get=get_Leaf  )) const ITEMIDLIST* Leaf[];

			const CIDA*	GetCIDA();
			HRESULT		GetAt(IEntry** ppShellItem, size_t index);

			/// ̃GgẑAw̃Gg𒊏o.
			HRESULT	CloneSubset(
				REFINTF pp,			///< oꂽz.
				size_t  subsets[],	///< oGgCfbNXz.
				size_t  length		///< subsets̒.
			);
		};

		/// VFtH_j[.
		__interface IFolder : ui::ITreeItem
		{
#ifndef DOXYGEN
			IEntry* get_Entry();
			bool    get_IncludeFiles();
			void    set_IncludeFiles(bool value);
			int     get_Depth();
			void    set_Depth(int depth);
#endif
			__declspec(property(get=get_Entry))                              IEntry* Entry; ///< Gg.
			__declspec(property(get=get_IncludeFiles, put=set_IncludeFiles)) bool IncludeFiles; ///< t@C܂ނۂ.
			__declspec(property(get=get_Depth       , put=set_Depth))        int Depth;     ///< WJ[.

			void Reset();
		};

		/// hbvGtFNg.
		enum DropEffect
		{
			DropEffectNone	= 0x00000000,
			DropEffectCopy	= 0x00000001,
			DropEffectMove	= 0x00000002,
			DropEffectLink	= 0x00000004,
		//	DropEffectScroll= 0x80000000 
		};

		/// hbOhbv\[X.
		__interface IDragSource : IDataObject
		{
			DropEffect DoDragDrop(DWORD dwSupportsEffect);
			DropEffect DoDragDrop(DWORD dwSupportsEffect, HWND hWndDrag, POINT ptCursor);
			DropEffect DoDragDrop(DWORD dwSupportsEffect, HBITMAP hBitmap, COLORREF colorkey, POINT ptHotspot);
			/// f[^ǉ.
			HRESULT AddData(CLIPFORMAT cfFormat, const void* data, size_t size);
			/// O[onhǉ.
			HRESULT AddGlobalData(CLIPFORMAT cfFormat, HGLOBAL hGlobal);
			/// ЂƂIDListǉ.
			HRESULT AddIDList(const ITEMIDLIST* pIDList);
			/// IDListzǉ.
			HRESULT AddIDList(const CIDA* pCIDA);
			/// eLXgǉ.
			HRESULT AddText(string text);
			/// URLǉ.
			HRESULT AddURL(string url);
		};

		//======================================================================
		// Version

		class Version
		{
		private:
			string	m_Path;
			BYTE*	m_VersionInfo;
			WORD	m_Language;
			WORD	m_CodePage;
		public:
			Version();
			~Version();
			string GetPath() const;
			bool Open(string filename);
			void Close();
			PCWSTR QueryValue(PCWSTR what);
		};
	}
}
