// signal.hpp
#pragma once

#include "message.hpp"

namespace mew
{
	//==============================================================================
	// C^tF[X

	__interface __declspec(uuid("91E42850-31CF-4B5E-A731-E24D46618E68")) ISignal;
	__interface __declspec(uuid("55A305E9-3FAC-4DC1-B992-F25B33D699DE")) IMessenger;

	//==============================================================================
	// 쐬\ȃNX

	/// ISignal̋@\ׂĎwp.
	/// WɂISignal̎ɗpł.
	class __declspec(uuid("9E76A64B-99FA-4F4C-A4BC-ED8EC3CFC31E")) Messenger;

	/// bZ[W\[X.
	__interface ISignal : IDisposable
	{
		/// VNo^.
		/// VNƃbZ[WR[hɓVNo^ς݂̏ꍇ́A֘AtꂽbZ[W㏑.
		/// @retval S_OK         o^.
		/// @retval E_INVALIDARG handlersA܂codeT|[gĂȂ.
		HRESULT Connect(
			EventCode code,      ///< o^郁bZ[WR[h. T|[gĂȂbZ[WR[h̏ꍇ͌Ăяos.
			function  fn,        ///< o^VN. null̏ꍇ͌Ăяos.
			message   msg = null ///< M郁bZ[W.
		) throw();
		/// VNo^.
		/// @result 폜ꂽVŇ.
		size_t Disconnect(
			EventCode code,      ///< 폜郁bZ[WR[h. 0̏ꍇ͑SẴR[h폜.
			function  fn,        ///< 폜VN. null̏ꍇ͑SĂ̊֐폜.
			IUnknown* obj = null ///< 폜VNIuWFNg. fnnullȊȌꍇ͖.
		) throw();
	};

	/// bZW[.
	__interface IMessenger : ISignal
	{
		/// bZ[W̔zMɎgp֐IuWFNgԂ.
		function Invoke(EventCode code) throw();
	};

	/// 
	template < int code > struct Event
	{
		template < class T > static void event(message& msg, T* from)
		{
			msg["from"] = from;
		}
	};

	/// bZ[W\[X̂߂̃bp.
	template < class TBase >
	class __declspec(novtable) SignalImpl : public TBase
	{
	protected:
		ref<IMessenger> m_msgr;

	protected: // invoke
		#define MEW_PP_MSGR_FMT(n)							\
			template < int code PP_TYPENAMES_CAT(n) >		\
			message InvokeEvent( PP_ARGS_CONST(n) ) const	\
			{												\
				if(!m_msgr) return null;					\
				function fn = m_msgr->Invoke(code);			\
				if(!fn) return null;						\
				message msg;								\
				Event<code>::event(msg, PP_ARG_VALUES(n));	\
				fn(msg);									\
				return msg;									\
			}

		PP_REPEAT(10, MEW_PP_MSGR_FMT)

		#undef MEW_PP_MSGR_FMT

	public:
		HRESULT Connect(EventCode code, function fn, message msg = null) throw()
		{
			return !m_msgr ? E_UNEXPECTED : m_msgr->Connect(code, fn, msg);
		}
		size_t Disconnect(EventCode code, function fn, IUnknown* obj = null) throw()
		{
			return !m_msgr ? 0 : m_msgr->Disconnect(code, fn, obj);
		}
	};
}
