// AvestaSDK.hpp

#pragma once

namespace avesta
{
	/// .
	enum AvestaComponent
	{
		AvestaForm,
		AvestaTab,
		AvestaFolder,
		AvestaStatus,
		AvestaPreview,
	};

	/// .
	enum NotifyPriority
	{
		NotifyIdle		=  0, // 
		NotifyInfo		= 10, // VXȅ
		NotifyResult	= 20, // [Ȗ̌
		NotifyWarning	= 30, // [Ǔ둀
		NotifyError		= 40, // VXe̓s
	};

	/// .
	enum Navigation
	{
		NaviCancel,		///< ړ
		NaviGoto,		///< ړ{L[
		NaviGotoAlways,	///< ړ
		NaviOpen,		///< J{L[
		NaviOpenAlways,	///< J
		NaviAppend,		///< ǉ
		NaviReserve,	///< ǉ{B
		NaviSwitch,		///< ǉ{tH[JX
		NaviReplace,	///< ǉ{tH[JX{B
	};

	///.
	enum Fonts
	{
		FontTab,
		FontAddress,
		FontList,
		FontStatus,
		NumOfFonts,
	};

	/// .
	__interface IAvesta
	{
		/// R|[lg擾.
		size_t GetComponentCount(AvestaComponent type);
		/// R|[lg擾.
		HRESULT GetComponent(REFINTF pp, AvestaComponent type, size_t index = (size_t)-1);
		/// IShellListView 񋓂.
		ref<IEnumUnknown> EnumFolders(Status status) const;

		ref<IShellListView>	CurrentView() const;
		ref<IEntry>			CurrentFolder() const;
		string				CurrentPath() const;

		/// tH_ƂĊJ܂.
		ref<IShellListView> OpenFolder(IEntry* entry, Navigation navi, Navigation* naviResult = null);
		/// tH_ƂĊJAs܂.
		HRESULT OpenOrExecute(IEntry* entry);

		/// ʒm[U̎זɂȂȂ悤ɕ\.
		void Notify(DWORD priority, string msg);
		///
		void ParseCommandLine(PCWSTR args);
		///
		void Restart(PCWSTR newDLL = null);
	};

	/// ֘Ats܂.
	HRESULT AvestaExecute(IEntry* entry);
}

namespace ave
{
	MEW_API void GetDriveLetter(PCWSTR path, PWSTR buffer);
	MEW_API UINT64 GetTotalBytes(IShellListView* view);
	MEW_API UINT64 GetSelectedBytes(IShellListView* view);

	inline string ResolvePath(PCWSTR path)
	{
		const int CSIDL_AVESTA = 0xFFFFFFFF;
		return io::PathResolvePath(path, L"AVESTA", CSIDL_AVESTA);
	}
	inline string ResolvePath(const string& path)
	{
		return ResolvePath(path.str());
	}
}

//==============================================================================

void	NewFolder(IShellListView* view);

void	DlgNew(IShellListView* view);
void	DlgSelect(IShellListView* view);
void	DlgPattern(IShellListView* view);
void	DlgRename(IShellListView* view, bool paste);

//void	DlgOpen(IShellListView* view);
